//
//  HTTPGetter.cpp
//
//  Created by Setsu on 5/4/10.
//  Copyright 2010 RoundSquare Inc. All rights reserved.
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
// 
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

//----------------------------------------
//	include
//----------------------------------------
#include <Poco/Net/HTTPRequest.h>
#include <Poco/Net/HTTPResponse.h>
#include <Poco/StreamCopier.h>

#include "HTTPGetter.h"

//----------------------------------------
//	HTTPGetter
//----------------------------------------
HTTPGetter::HTTPGetter(const std::string& host, Poco::UInt16 port) :
		mHost	(host)
	,	mPort	(port)
{
}

HTTPGetter::~HTTPGetter()
{
}

int HTTPGetter::Get(const std::string& path, std::ostream& ostr)
{
	try
	{
		const std::string myPath = ('/' == path.c_str()[0]) ? path:("/"+path);

		Poco::Net::HTTPClientSession session(mHost, mPort);
		Poco::Net::HTTPRequest req(Poco::Net::HTTPRequest::HTTP_GET, path, Poco::Net::HTTPMessage::HTTP_1_1);
		session.sendRequest(req);
		Poco::Net::HTTPResponse res;
		std::istream& rs = session.receiveResponse(res);
		Poco::StreamCopier::copyStream(rs, ostr);
	}
	catch (Poco::Exception& /*exc*/)
	{
		return -1;
	}
	return 0;
}
